/*******************************************************************************
 *  Copyright CONSORTIUM COCKTAIL (www.cocktail.org), 1995, 2008
 *  
 *  This software is governed by the CeCILL license under French law and abiding
 *  by the rules of distribution of free software. You can use, modify and/or
 *  redistribute the software under the terms of the CeCILL license as circulated
 *  by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".
 *  
 *  As a counterpart to the access to the source code and rights to copy, modify
 *  and redistribute granted by the license, users are provided only with a
 *  limited warranty and the software's author, the holder of the economic
 *  rights, and the successive licensors have only limited liability.
 *  
 *  In this respect, the user's attention is drawn to the risks associated with
 *  loading, using, modifying and/or developing or reproducing the software by
 *  the user in light of its specific status of free software, that may mean that
 *  it is complicated to manipulate, and that also therefore means that it is
 *  reserved for developers and experienced professionals having in-depth
 *  computer knowledge. Users are therefore encouraged to load and test the
 *  software's suitability as regards their requirements in conditions enabling
 *  the security of their systems and/or data to be ensured and, more generally,
 *  to use and operate it in the same conditions as regards security.
 *  
 *  The fact that you are presently reading this means that you have had
 *  knowledge of the CeCILL license and that you accept its terms.
 * 
 *******************************************************************************/

package org.cocktail.abricot.client.gui;

import java.awt.BorderLayout;
import java.math.BigDecimal;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.abricot.client.eof.modele.EOVAbricotPapayeAttente;
import org.cocktail.abricot.client.eof.modele.EOVAbricotDepenseAMandater;
import org.cocktail.client.common.swing.TableSorter;
import org.cocktail.client.common.swing.ZEOTable;
import org.cocktail.client.common.swing.ZEOTableModel;
import org.cocktail.client.common.swing.ZEOTableModelColumn;
import org.cocktail.client.common.utilities.CocktailConstantes;
import org.cocktail.client.common.utilities.CocktailFormats;
import org.cocktail.client.common.utilities.CocktailIcones;

import com.webobjects.eointerface.EODisplayGroup;

/**
 * 
 * @author cpinsard
 */
public class PayeView extends javax.swing.JFrame {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	protected EODisplayGroup eodUb, eodDepenses;
	protected ZEOTable myEOTableUb, myEOTableDepenses;
	protected ZEOTableModel myTableModelUb, myTableModelDepenses;
	protected TableSorter myTableSorterUb, myTableSorterDepensess;

	/** Creates new form AffichageBSView */
	public PayeView(java.awt.Frame parent, boolean modal,
			EODisplayGroup dgDepenses, EODisplayGroup dgSelection) {
		//super(parent, modal);

		eodUb = dgDepenses;
		eodDepenses = dgSelection;

		initComponents();

		initGui();
	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */

	// <editor-fold defaultstate="collapsed"
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        btnRefresh = new javax.swing.JButton();
        btnFermer = new javax.swing.JButton();
        tfTitre = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        viewTableComposantes = new javax.swing.JPanel();
        btnCreerBordereau = new javax.swing.JButton();
        btnPrint = new javax.swing.JButton();
        viewTableDepenses = new javax.swing.JPanel();
        lblDepenses = new javax.swing.JLabel();
        checkPaf = new javax.swing.JRadioButton();
        checkPapaye = new javax.swing.JRadioButton();
        jLabel1 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        btnRefresh.setText("Rafraîchir");
        btnRefresh.setToolTipText("Rafraichir la liste des dépenses");

        btnFermer.setText("Fermer");
        btnFermer.setToolTipText("Fermer la fenêtre");

        tfTitre.setBackground(new java.awt.Color(153, 153, 153));
        tfTitre.setEditable(false);
        tfTitre.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        tfTitre.setText("PAYES");
        tfTitre.setFocusable(false);

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel2.setText("TYPE DE BORDEREAU :");

        viewTableComposantes.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        viewTableComposantes.setLayout(new java.awt.BorderLayout());

        btnCreerBordereau.setText("Créer Bordereau");
        btnCreerBordereau.setToolTipText("Fermer la fenêtre");

        btnPrint.setText("Imprimer");
        btnPrint.setToolTipText("Fermer la fenêtre");

        viewTableDepenses.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        viewTableDepenses.setLayout(new java.awt.BorderLayout());

        lblDepenses.setFont(new java.awt.Font("Tahoma", 0, 14));
        lblDepenses.setForeground(new java.awt.Color(0, 51, 255));
        lblDepenses.setText("7 Dépenses - 10595,56€");

        buttonGroup1.add(checkPaf);
        checkPaf.setText("PAF");

        buttonGroup1.add(checkPapaye);
        checkPapaye.setText("PAPAYE");

        jLabel1.setText("Liste des composantes à mandater");

        jLabel3.setText("Détail des dépenses");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(tfTitre, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 988, Short.MAX_VALUE)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 127, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(18, 18, 18)
                .add(checkPaf, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 72, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(10, 10, 10)
                .add(checkPapaye, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 102, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 497, Short.MAX_VALUE)
                .add(btnRefresh, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 121, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(31, 31, 31))
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, viewTableComposantes, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 947, Short.MAX_VALUE)
                    .add(layout.createSequentialGroup()
                        .add(jLabel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 327, Short.MAX_VALUE)
                        .add(620, 620, 620)))
                .add(31, 31, 31))
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 287, Short.MAX_VALUE)
                .add(691, 691, 691))
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(viewTableDepenses, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 947, Short.MAX_VALUE)
                .add(31, 31, 31))
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(lblDepenses, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 365, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 162, Short.MAX_VALUE)
                .add(btnPrint, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 149, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(btnCreerBordereau, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 149, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(btnFermer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 110, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(31, 31, 31))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(tfTitre, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(18, 18, 18)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 14, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                .add(checkPapaye, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .add(checkPaf, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                        .add(17, 17, 17))
                    .add(btnRefresh, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 34, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(0, 0, 0)
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(viewTableComposantes, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 154, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jLabel3)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(viewTableDepenses, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 273, Short.MAX_VALUE)
                .add(18, 18, 18)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(lblDepenses)
                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                        .add(btnFermer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, Short.MAX_VALUE)
                        .add(btnCreerBordereau, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, Short.MAX_VALUE)
                        .add(btnPrint, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .add(26, 26, 26))
        );

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-1004)/2, (screenSize.height-655)/2, 1004, 655);
    }// </editor-fold>//GEN-END:initComponents

	/**
	 * @param args
	 *            the command line arguments
	 */
	public static void main(String args[]) {
		java.awt.EventQueue.invokeLater(new Runnable() {
			public void run() {
				MandatView dialog = new MandatView(new javax.swing.JFrame(),
						true, null, null, null);
				dialog.addWindowListener(new java.awt.event.WindowAdapter() {
					public void windowClosing(java.awt.event.WindowEvent e) {
						System.exit(0);
					}
				});
				dialog.setVisible(true);
			}
		});
	}

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCreerBordereau;
    private javax.swing.JButton btnFermer;
    private javax.swing.JButton btnPrint;
    private javax.swing.JButton btnRefresh;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JRadioButton checkPaf;
    private javax.swing.JRadioButton checkPapaye;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel lblDepenses;
    private javax.swing.JTextField tfTitre;
    protected javax.swing.JPanel viewTableComposantes;
    protected javax.swing.JPanel viewTableDepenses;
    // End of variables declaration//GEN-END:variables

	/*
	 * (non-Javadoc)
	 * 
	 * @see fr.univlr.karukera.client.ZKarukeraPanel#initGUI()
	 */
	private void initGui() {

		btnFermer.setIcon(CocktailIcones.ICON_CLOSE);

		btnRefresh.setIcon(CocktailIcones.ICON_REFRESH_22);

		btnPrint.setIcon(CocktailIcones.ICON_PRINTER_16);

		btnCreerBordereau.setIcon(CocktailIcones.ICON_ADD);

		Vector<ZEOTableModelColumn> myCols = new Vector<ZEOTableModelColumn>();

		myCols = new Vector<ZEOTableModelColumn>();

		ZEOTableModelColumn col = new ZEOTableModelColumn(eodUb,
				EOVAbricotPapayeAttente.MOIS_KEY, "Mois", 20);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);

		col = new ZEOTableModelColumn(eodUb,
				EOVAbricotPapayeAttente.ORG_UB_KEY, "UB", 30);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);

		col = new ZEOTableModelColumn(eodUb,
				EOVAbricotPapayeAttente.NB_ATTENTE_KEY, "En Attente", 60);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);

		col = new ZEOTableModelColumn(eodUb,
				EOVAbricotPapayeAttente.MONTANT_KEY, "Montant", 35);
		col.setColumnClass(BigDecimal.class);
		col.setFormatDisplay(CocktailFormats.FORMAT_DECIMAL);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);

		myTableModelUb = new ZEOTableModel(eodUb, myCols);
		myTableSorterUb = new TableSorter(myTableModelUb);

		myEOTableUb = new ZEOTable(myTableSorterUb);
		myTableSorterUb.setTableHeader(myEOTableUb.getTableHeader());

		myEOTableUb.setBackground(CocktailConstantes.COLOR_FOND_NOMENCLATURES);
		myEOTableUb
				.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTableUb
				.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);

		viewTableComposantes.setBorder(BorderFactory.createEmptyBorder());
		viewTableComposantes.removeAll();
		viewTableComposantes.setLayout(new BorderLayout());
		viewTableComposantes.add(new JScrollPane(myEOTableUb),
				BorderLayout.CENTER);

		myCols = new Vector<ZEOTableModelColumn>();

		col = new ZEOTableModelColumn(eodDepenses,
				EOVAbricotDepenseAMandater.DPP_NUMERO_FACTURE_KEY, "Mois", 20);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);

		col = new ZEOTableModelColumn(eodDepenses,
				EOVAbricotDepenseAMandater.ORG_CR_KEY, "CR", 30);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);

		col = new ZEOTableModelColumn(eodDepenses,
				EOVAbricotDepenseAMandater.ORG_SOUSCR_KEY, "SOUS CR", 60);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);

		col = new ZEOTableModelColumn(eodDepenses,
				EOVAbricotDepenseAMandater.DPCO_TTC_SAISIE_KEY, "Montant", 35);
		col.setAlignment(SwingConstants.RIGHT);
		col.setColumnClass(BigDecimal.class);
		col.setFormatDisplay(CocktailFormats.FORMAT_DECIMAL);
		myCols.add(col);

		col = new ZEOTableModelColumn(eodDepenses,
				EOVAbricotDepenseAMandater.PCO_NUM_KEY, "Imputation", 40);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);

		col = new ZEOTableModelColumn(eodDepenses,
				EOVAbricotDepenseAMandater.TCD_CODE_KEY, "Crédit", 35);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);

		myTableModelDepenses = new ZEOTableModel(eodDepenses, myCols);
		myTableSorterDepensess = new TableSorter(myTableModelDepenses);

		myEOTableDepenses = new ZEOTable(myTableSorterDepensess);
		myTableSorterDepensess.setTableHeader(myEOTableDepenses
				.getTableHeader());

		myEOTableDepenses
				.setBackground(CocktailConstantes.COLOR_FOND_NOMENCLATURES);
		myEOTableDepenses
				.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTableDepenses
				.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);

		viewTableDepenses.setBorder(BorderFactory.createEmptyBorder());
		viewTableDepenses.removeAll();
		viewTableDepenses.setLayout(new BorderLayout());
		viewTableDepenses.add(new JScrollPane(myEOTableDepenses),
				BorderLayout.CENTER);
	}

	public ZEOTable getMyEOTableUb() {
		return myEOTableUb;
	}

	public void setMyEOTableUb(ZEOTable myEOTableUb) {
		this.myEOTableUb = myEOTableUb;
	}

	public ZEOTable getMyEOTableDepenses() {
		return myEOTableDepenses;
	}

	public void setMyEOTableDepenses(ZEOTable myEOTableDepenses) {
		this.myEOTableDepenses = myEOTableDepenses;
	}

	public javax.swing.JButton getBtnCreerBordereau() {
		return btnCreerBordereau;
	}

	public void setBtnCreerBordereau(javax.swing.JButton btnCreerBordereau) {
		this.btnCreerBordereau = btnCreerBordereau;
	}

	public javax.swing.JButton getBtnFermer() {
		return btnFermer;
	}

	public void setBtnFermer(javax.swing.JButton btnFermer) {
		this.btnFermer = btnFermer;
	}

	public javax.swing.JButton getBtnPrint() {
		return btnPrint;
	}

	public void setBtnPrint(javax.swing.JButton btnPrint) {
		this.btnPrint = btnPrint;
	}

	public javax.swing.JButton getBtnRefresh() {
		return btnRefresh;
	}

	public void setBtnRefresh(javax.swing.JButton btnRefresh) {
		this.btnRefresh = btnRefresh;
	}

	public javax.swing.JRadioButton getCheckPaf() {
		return checkPaf;
	}

	public javax.swing.JLabel getLblDepenses() {
		return lblDepenses;
	}

	public void setLblDepenses(javax.swing.JLabel lblDepenses) {
		this.lblDepenses = lblDepenses;
	}

	public void setCheckPaf(javax.swing.JRadioButton checkPaf) {
		this.checkPaf = checkPaf;
	}

	public javax.swing.JRadioButton getCheckPapaye() {
		return checkPapaye;
	}

	public void setCheckPapaye(javax.swing.JRadioButton checkPapaye) {
		this.checkPapaye = checkPapaye;
	}

	public javax.swing.JTextField getTfTitre() {
		return tfTitre;
	}

	public void setTfTitre(javax.swing.JTextField tfTitre) {
		this.tfTitre = tfTitre;
	}

}
